
	CREATE SEQUENCE  "TADPLACEMENTDETAILS_DETAILID_S" MINVALUE 1 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--|
	CREATE SEQUENCE  "TADSTATS_STATID_SEQ" MINVALUE 1 NOMAXVALUE INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--|
	CREATE SEQUENCE  "TCLASSEXTENDATTRIBUTES_ATTRIBU" MINVALUE 1  INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--|
	CREATE SEQUENCE  "TCLASSEXTENDDATAUSERACTIVITY_D" MINVALUE 1 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--|
   CREATE SEQUENCE  "TCLASSEXTENDDATA_DATAID_SEQ" MINVALUE 1 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--|
   CREATE SEQUENCE  "TCONTENTTAGS_TAGID_SEQ" MINVALUE 1 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--|
   CREATE SEQUENCE  "TCONTENT_TCONTENT_ID_SEQ"  MINVALUE 1 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--|
   CREATE SEQUENCE  "TSESSIONTRACKING_TRACKINGID_SE" MINVALUE 1 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--|
   CREATE SEQUENCE  "TUSERSTAGS_TAGID_SEQ"  MINVALUE 1 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--|

  CREATE TABLE "TADCAMPAIGNS" 
   (	"CAMPAIGNID" CHAR(35), 
	"USERID" CHAR(35), 
	"DATECREATED" DATE, 
	"LASTUPDATE" DATE, 
	"LASTUPDATEBY" VARCHAR2(50), 
	"NAME" VARCHAR2(50), 
	"STARTDATE" DATE, 
	"ENDDATE" DATE, 
	"ISACTIVE" NUMBER(10,0), 
	"NOTES" CLOB
   ) 
	lob (NOTES) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TADCREATIVES" 
   (	"CREATIVEID" CHAR(35), 
	"USERID" CHAR(35), 
	"DATECREATED" DATE, 
	"LASTUPDATE" DATE, 
	"LASTUPDATEBY" VARCHAR2(50), 
	"NAME" VARCHAR2(50), 
	"CREATIVETYPE" VARCHAR2(50), 
	"FILEID" VARCHAR2(35), 
	"MEDIATYPE" VARCHAR2(50), 
	"REDIRECTURL" VARCHAR2(100), 
	"ALTTEXT" VARCHAR2(100), 
	"NOTES" CLOB, 
	"ISACTIVE" NUMBER(10,0), 
	"HEIGHT" NUMBER(10,0), 
	"WIDTH" NUMBER(10,0), 
	"TEXTBODY" CLOB
   ) 
	lob (NOTES, TEXTBODY) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TADIPWHITELIST" 
   (	"IP" VARCHAR2(50), 
	"SITEID" VARCHAR2(50)
   ) ;
--|



  CREATE TABLE "TADPLACEMENTS" 
   (	"PLACEMENTID" CHAR(35), 
	"CAMPAIGNID" CHAR(35), 
	"ADZONEID" CHAR(35), 
	"CREATIVEID" CHAR(35), 
	"DATECREATED" DATE, 
	"LASTUPDATE" DATE, 
	"LASTUPDATEBY" VARCHAR2(50), 
	"STARTDATE" DATE, 
	"ENDDATE" DATE, 
	"COSTPERIMP" FLOAT(126), 
	"COSTPERCLICK" FLOAT(126), 
	"ISEXCLUSIVE" NUMBER(10,0), 
	"BILLABLE" FLOAT(126), 
	"BUDGET" NUMBER(10,0), 
	"ISACTIVE" NUMBER(10,0), 
	"NOTES" CLOB
   ) 
	lob (NOTES) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|


  CREATE TABLE "TADPLACEMENTDETAILS" 
   (	"DETAILID" NUMBER(12,0), 
	"PLACEMENTID" CHAR(35), 
	"PLACEMENTTYPE" CHAR(35), 
	"PLACEMENTVALUE" NUMBER(10,0) DEFAULT '0'
) ;
--|

  CREATE TABLE "TADSTATS" 
   (	"STATID" NUMBER(12,0), 
	"PLACEMENTID" CHAR(35), 
	"STATHOUR" NUMBER(10,0), 
	"STATDATE" DATE, 
	"TYPE" VARCHAR2(50), 
	"COUNTER" NUMBER(10,0)
   ) ;
--|

  CREATE TABLE "TADZONES" 
   (	"ADZONEID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"DATECREATED" DATE, 
	"LASTUPDATE" DATE, 
	"LASTUPDATEBY" VARCHAR2(50), 
	"NAME" VARCHAR2(50), 
	"CREATIVETYPE" VARCHAR2(50), 
	"NOTES" CLOB, 
	"ISACTIVE" NUMBER(10,0), 
	"HEIGHT" NUMBER(10,0), 
	"WIDTH" NUMBER(10,0)
   ) 
	lob (NOTES) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TCAPTCHA" 
   (	"LETTERID" NUMBER(10,0) DEFAULT '0', 
	"LETTER" CHAR(1), 
	"IMAGEFILE" VARCHAR2(50)
   ) ;
--|

  CREATE TABLE "TCLASSEXTEND" 
   (	"SUBTYPEID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"BASETABLE" VARCHAR2(50), 
	"BASEKEYFIELD" VARCHAR2(50), 
	"DATATABLE" VARCHAR2(50), 
	"TYPE" VARCHAR2(50), 
	"SUBTYPE" VARCHAR2(50), 
	"ISACTIVE" NUMBER(3,0), 
	"NOTES" CLOB, 
	"LASTUPDATE" DATE, 
	"DATECREATED" DATE, 
	"LASTUPDATEBY" VARCHAR2(100)
   ) 
	lob (NOTES) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TCLASSEXTENDATTRIBUTES" 
   (	"ATTRIBUTEID" NUMBER(12,0), 
	"EXTENDSETID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"NAME" VARCHAR2(100), 
	"LABEL" CLOB, 
	"HINT" CLOB, 
	"TYPE" VARCHAR2(100), 
	"ORDERNO" NUMBER(10,0), 
	"ISACTIVE" NUMBER(3,0), 
	"REQUIRED" VARCHAR2(50), 
	"VALIDATION" VARCHAR2(50), 
	"REGEX" CLOB, 
	"MESSAGE" CLOB, 
	"DEFAULTVALUE" VARCHAR2(100), 
	"OPTIONLIST" CLOB, 
	"OPTIONLABELLIST" CLOB
   )
 	lob (LABEL, HINT, REGEX, MESSAGE, OPTIONLIST, OPTIONLABELLIST) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TCLASSEXTENDDATA" 
   (	"DATAID" NUMBER(12,0), 
	"BASEID" CHAR(35), 
	"ATTRIBUTEID" NUMBER(10,0), 
	"SITEID" VARCHAR2(25), 
	"ATTRIBUTEVALUE" CLOB
   ) 
	lob (ATTRIBUTEVALUE) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TCLASSEXTENDDATAUSERACTIVITY" 
   (	"DATAID" NUMBER(12,0), 
	"BASEID" CHAR(35), 
	"ATTRIBUTEID" NUMBER(10,0), 
	"SITEID" VARCHAR2(25), 
	"ATTRIBUTEVALUE" CLOB
   ) 
	lob (ATTRIBUTEVALUE) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TCLASSEXTENDSETS" 
   (	"EXTENDSETID" CHAR(35), 
	"SUBTYPEID" CHAR(35), 
	"CATEGORYID" CLOB, 
	"SITEID" VARCHAR2(25), 
	"NAME" VARCHAR2(50), 
	"ORDERNO" NUMBER(10,0), 
	"ISACTIVE" NUMBER(3,0)
   )
 	lob (CATEGORYID) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TCONTENT" 
   (	"TCONTENT_ID" NUMBER(12,0), 
	"SITEID" VARCHAR2(25), 
	"MODULEID" CHAR(35), 
	"PARENTID" CHAR(35), 
	"CONTENTID" CHAR(35), 
	"CONTENTHISTID" CHAR(35), 
	"REMOTEID" VARCHAR2(255), 
	"REMOTEURL" VARCHAR2(255), 
	"REMOTEPUBDATE" VARCHAR2(50), 
	"REMOTESOURCEURL" VARCHAR2(255), 
	"REMOTESOURCE" VARCHAR2(255), 
	"CREDITS" VARCHAR2(255), 
	"FILEID" CHAR(35), 
	"TEMPLATE" VARCHAR2(50), 
	"TYPE" VARCHAR2(25), 
	"SUBTYPE" VARCHAR2(25), 
	"ACTIVE" NUMBER(3,0) DEFAULT '0', 
	"ORDERNO" NUMBER(10,0), 
	"TITLE" VARCHAR2(255), 
	"MENUTITLE" VARCHAR2(255), 
	"SUMMARY" CLOB, 
	"FILENAME" VARCHAR2(255), 
	"METADESC" CLOB, 
	"METAKEYWORDS" CLOB, 
	"BODY" CLOB, 
	"LASTUPDATE" DATE, 
	"LASTUPDATEBY" VARCHAR2(50), 
	"LASTUPDATEBYID" VARCHAR2(50), 
	"DISPLAYSTART" DATE, 
	"DISPLAYSTOP" DATE, 
	"DISPLAY" NUMBER(3,0), 
	"APPROVED" NUMBER(3,0), 
	"ISNAV" NUMBER(3,0), 
	"RESTRICTED" NUMBER(3,0), 
	"RESTRICTGROUPS" VARCHAR2(255), 
	"TARGET" VARCHAR2(25), 
	"TARGETPARAMS" VARCHAR2(255), 
	"RESPONSECHART" NUMBER(3,0), 
	"RESPONSEMESSAGE" CLOB, 
	"RESPONSESENDTO" CLOB, 
	"RESPONSEDISPLAYFIELDS" CLOB, 
	"MODULEASSIGN" VARCHAR2(255), 
	"DISPLAYTITLE" NUMBER(3,0), 
	"NOTES" CLOB, 
	"INHERITOBJECTS" VARCHAR2(25), 
	"ISFEATURE" NUMBER(3,0), 
	"RELEASEDATE" DATE, 
	"ISLOCKED" NUMBER(3,0), 
	"NEXTN" NUMBER(10,0), 
	"SORTBY" VARCHAR2(50), 
	"SORTDIRECTION" VARCHAR2(50), 
	"FEATURESTART" DATE, 
	"FEATURESTOP" DATE, 
	"FORCESSL" NUMBER(3,0) DEFAULT '0', 
	"AUDIENCE" CLOB, 
	"KEYPOINTS" CLOB, 
	"SEARCHEXCLUDE" NUMBER(3,0), 
	"PATH" CLOB, 
	"TAGS" CLOB
   ) 
	lob (SUMMARY, METADESC, METAKEYWORDS, BODY, AUDIENCE, KEYPOINTS, TAGS, RESPONSEMESSAGE, RESPONSESENDTO, PATH, NOTES) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TCONTENTASSIGNMENTS" 
   (	"CONTENTID" CHAR(35), 
	"CONTENTHISTID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"USERID" CHAR(35)
   ) ;
--|

  CREATE TABLE "TCONTENTCATEGORIES" 
   (	"CATEGORYID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"PARENTID" CHAR(35), 
	"DATECREATED" DATE, 
	"LASTUPDATE" DATE, 
	"LASTUPDATEBY" VARCHAR2(50), 
	"NAME" VARCHAR2(50), 
	"NOTES" CLOB, 
	"ISINTERESTGROUP" NUMBER(10,0), 
	"ISACTIVE" NUMBER(10,0), 
	"ISOPEN" NUMBER(10,0), 
	"SORTBY" VARCHAR2(50), 
	"SORTDIRECTION" VARCHAR2(50), 
	"RESTRICTGROUPS" VARCHAR2(255), 
	"PATH" CLOB
   ) 
	lob (NOTES, PATH) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TCONTENTCATEGORYASSIGN" 
   (	"CONTENTHISTID" CHAR(35), 
	"CATEGORYID" CHAR(35), 
	"CONTENTID" CHAR(35), 
	"ISFEATURE" NUMBER(10,0), 
	"ORDERNO" NUMBER(10,0), 
	"SITEID" VARCHAR2(25), 
	"FEATURESTART" DATE, 
	"FEATURESTOP" DATE
   ) ;
--|

  CREATE TABLE "TCONTENTCOMMENTS" 
   (	"COMMENTID" CHAR(35), 
	"CONTENTID" CHAR(35), 
	"CONTENTHISTID" CHAR(35), 
	"URL" VARCHAR2(50), 
	"NAME" VARCHAR2(50), 
	"ENTERED" DATE, 
	"EMAIL" VARCHAR2(100), 
	"SITEID" VARCHAR2(25), 
	"IP" VARCHAR2(50), 
	"ISAPPROVED" NUMBER(3,0) DEFAULT '0', 
	"COMMENTS" CLOB
   ) 
	lob (COMMENTS) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TCONTENTDISPLAYTITLEAPPROVALS" 
   (	"CONTENTID" CHAR(35), 
	"ISAPPROVED" NUMBER(3,0), 
	"EMAIL" VARCHAR2(150), 
	"SITEID" VARCHAR2(25)
   ) ;
--|

  CREATE TABLE "TCONTENTEVENTREMINDERS" 
   (	"CONTENTID" CHAR(35), 
	"SITEID" VARCHAR2(35), 
	"EMAIL" VARCHAR2(200), 
	"REMINDDATE" DATE, 
	"REMINDHOUR" NUMBER(10,0), 
	"REMINDMINUTE" NUMBER(10,0), 
	"REMINDINTERVAL" NUMBER(10,0), 
	"ISSENT" NUMBER(10,0)
   ) ;
--|

  CREATE TABLE "TCONTENTFEEDADVANCEDPARAMS" 
   (	"PARAMID" CHAR(35), 
	"FEEDID" CHAR(35), 
	"PARAM" FLOAT(126), 
	"RELATIONSHIP" VARCHAR2(50), 
	"FIELD" VARCHAR2(100), 
	"CONDITION" VARCHAR2(50), 
	"CRITERIA" VARCHAR2(200), 
	"DATATYPE" VARCHAR2(50)
   ) ;
--|

  CREATE TABLE "TCONTENTFEEDITEMS" 
   (	"FEEDID" CHAR(35), 
	"ITEMID" CHAR(35), 
	"TYPE" VARCHAR2(50)
   ) ;
--|

  CREATE TABLE "TCONTENTFEEDS" 
   (	"FEEDID" CHAR(35), 
	"SITEID" VARCHAR2(35), 
	"PARENTID" CHAR(35), 
	"NAME" VARCHAR2(250), 
	"ISACTIVE" NUMBER(3,0), 
	"ISPUBLIC" NUMBER(3,0), 
	"ISDEFAULT" NUMBER(3,0), 
	"ISFEATURESONLY" NUMBER(3,0), 
	"DESCRIPTION" CLOB, 
	"MAXITEMS" NUMBER(10,0), 
	"ALLOWHTML" NUMBER(3,0), 
	"LANG" VARCHAR2(50), 
	"LASTUPDATEBY" VARCHAR2(100), 
	"LASTUPDATE" DATE, 
	"DATECREATED" DATE, 
	"RESTRICTED" NUMBER(3,0), 
	"RESTRICTGROUPS" CLOB, 
	"VERSION" VARCHAR2(50), 
	"CHANNELLINK" VARCHAR2(250), 
	"TYPE" VARCHAR2(50), 
	"SORTBY" VARCHAR2(50), 
	"SORTDIRECTION" VARCHAR2(50), 
	"NEXTN" NUMBER(10,0), 
	"DISPLAYNAME" NUMBER(3,0), 
	"DISPLAYRATINGS" NUMBER(3,0), 
	"DISPLAYCOMMENTS" NUMBER(3,0)
   )
 	lob (DESCRIPTION) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TCONTENTOBJECTS" 
   (	"CONTENTHISTID" CHAR(35), 
	"OBJECTID" VARCHAR2(100), 
	"OBJECT" VARCHAR2(50), 
	"CONTENTID" CHAR(35), 
	"NAME" VARCHAR2(255), 
	"ORDERNO" NUMBER(10,0), 
	"SITEID" VARCHAR2(25), 
	"COLUMNID" NUMBER(10,0) DEFAULT '0'
   ) ;
--|

  CREATE TABLE "TCONTENTPUBLICSUBMISSIONAPPROV" 
   (	"CONTENTID" CHAR(35), 
	"ISAPPROVED" NUMBER(10,0), 
	"EMAIL" VARCHAR2(150), 
	"SITEID" VARCHAR2(25)
   ) ;
--|

	COMMENT ON TABLE "TCONTENTPUBLICSUBMISSIONAPPROV"  IS 'ORIGINAL NAME:tcontentpublicsubmissionapprovals';
--|

  CREATE TABLE "TCONTENTRATINGS" 
   (	"CONTENTID" CHAR(35), 
	"USERID" CHAR(35), 
	"SITEID" VARCHAR2(35), 
	"RATE" NUMBER(10,0), 
	"ENTERED" DATE DEFAULT SYSDATE
   ) ;
--|

  CREATE TABLE "TCONTENTRELATED" 
   (	"CONTENTHISTID" CHAR(35), 
	"RELATEDID" CHAR(35), 
	"CONTENTID" CHAR(35), 
	"SITEID" VARCHAR2(25)
   ) ;
--|

  CREATE TABLE "TCONTENTSTATS" 
   (	"CONTENTID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"VIEWS" NUMBER(10,0) DEFAULT '0', 
	"RATING" FLOAT(126) DEFAULT '0', 
	"TOTALVOTES" NUMBER(10,0) DEFAULT '0', 
	"UPVOTES" NUMBER(10,0) DEFAULT '0', 
	"DOWNVOTES" NUMBER(10,0) DEFAULT '0', 
	"COMMENTS" NUMBER(10,0) DEFAULT '0'
   ) ;
--|

  CREATE TABLE "TCONTENTTAGS" 
   (	"TAGID" NUMBER(12,0), 
	"CONTENTID" CHAR(35), 
	"CONTENTHISTID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"TAG" VARCHAR2(100)
   ) ;
--|

  CREATE TABLE "TEMAILRETURNSTATS" 
   (	"EMAILID" CHAR(35), 
	"EMAIL" VARCHAR2(100), 
	"URL" VARCHAR2(500), 
	"CREATED" DATE
   ) ;
--|

  CREATE TABLE "TEMAILS" 
   (	"EMAILID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"SUBJECT" VARCHAR2(255), 
	"BODYTEXT" CLOB, 
	"BODYHTML" CLOB, 
	"CREATEDDATE" DATE, 
	"DELIVERYDATE" DATE, 
	"STATUS" NUMBER(3,0), 
	"GROUPLIST" CLOB, 
	"LASTUPDATEBY" VARCHAR2(50), 
	"LASTUPDATEBYID" VARCHAR2(35), 
	"NUMBERSENT" NUMBER(10,0) DEFAULT '0', 
	"REPLYTO" VARCHAR2(50), 
	"FORMAT" VARCHAR2(50), 
	"FROMLABEL" VARCHAR2(50), 
	"ISDELETED" NUMBER(3,0) DEFAULT '0'
   ) 
	lob (BODYHTML, BODYTEXT, GROUPLIST) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TEMAILSTATS" 
   (	"EMAILID" CHAR(35), 
	"EMAIL" CHAR(100), 
	"EMAILOPEN" NUMBER(10,0) DEFAULT '0', 
	"RETURNCLICK" NUMBER(10,0) DEFAULT '0', 
	"BOUNCE" NUMBER(10,0) DEFAULT '0', 
	"SENT" NUMBER(10,0) DEFAULT '0', 
	"CREATED" DATE
   ) ;
--|

  CREATE TABLE "TFILES" 
   (	"FILEID" CHAR(35), 
	"CONTENTID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"MODULEID" CHAR(35), 
	"FILENAME" VARCHAR2(200), 
	"IMAGE" BLOB, 
	"IMAGESMALL" BLOB, 
	"IMAGEMEDIUM" BLOB, 
	"FILESIZE" NUMBER(10,0), 
	"CONTENTTYPE" VARCHAR2(100), 
	"CONTENTSUBTYPE" VARCHAR2(200), 
	"FILEEXT" VARCHAR2(50), 
	"CREATED" DATE
   ) 
	lob (IMAGE, IMAGESMALL, IMAGEMEDIUM) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TFORMRESPONSEPACKETS" 
   (	"RESPONSEID" CHAR(35), 
	"FORMID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"FIELDLIST" CLOB, 
	"DATA" CLOB, 
	"ENTERED" DATE
   ) 
	lob (FIELDLIST, DATA) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TFORMRESPONSEQUESTIONS" 
   (	"RESPONSEID" CHAR(35), 
	"FORMID" CHAR(35), 
	"FORMFIELD" VARCHAR2(50), 
	"FORMVALUE" CLOB, 
	"POLLVALUE" VARCHAR2(255)
   ) 
	lob (FORMVALUE) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TGLOBALS" 
   (	"APPRELOAD" DATE, 
	"LOADLIST" CLOB
   ) ;
--|

  CREATE TABLE "TMAILINGLIST" 
   (	"MLID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"NAME" VARCHAR2(50), 
	"DESCRIPTION" CLOB, 
	"LASTUPDATE" DATE, 
	"ISPURGE" NUMBER(10,0), 
	"ISPUBLIC" NUMBER(10,0)
   ) 
	lob (DESCRIPTION) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TMAILINGLISTMEMBERS" 
   (	"MLID" CHAR(35), 
	"EMAIL" VARCHAR2(100), 
	"SITEID" VARCHAR2(25), 
	"FNAME" VARCHAR2(50), 
	"LNAME" VARCHAR2(50), 
	"COMPANY" VARCHAR2(50), 
	"ISVERIFIED" NUMBER(3,0) DEFAULT '0'
   ) ;
--|

  CREATE TABLE "TPERMISSIONS" 
   (	"CONTENTID" CHAR(35), 
	"GROUPID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"TYPE" VARCHAR2(50)
   ) ;
--|

  CREATE TABLE "TREDIRECTS" 
   (	"REDIRECTID" CHAR(35), 
	"URL" CLOB, 
	"CREATED" DATE
   ) ;
--|

  CREATE TABLE "TSESSIONTRACKING" 
   (	"TRACKINGID" NUMBER(12,0), 
	"CONTENTID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"USERID" CHAR(35), 
	"REMOTE_ADDR" VARCHAR2(50), 
	"SERVER_NAME" VARCHAR2(50), 
	"USER_AGENT" VARCHAR2(200), 
	"SCRIPT_NAME" VARCHAR2(200), 
	"URLTOKEN" VARCHAR2(130), 
	"ENTERED" DATE DEFAULT to_date('01-JAN-70 00:00:00', 'dd-MON-yy hh24:mi:ss'), 
	"COUNTRY" VARCHAR2(50), 
	"LANG" VARCHAR2(50), 
	"LOCALE" VARCHAR2(50), 
	"KEYWORDS" VARCHAR2(200), 
	"ORIGINALURLTOKEN" VARCHAR2(130), 
	"QUERY_STRING" VARCHAR2(400), 
	"REFERER" VARCHAR2(255)
   ) ;
--|

  CREATE TABLE "TSETTINGS" 
   (	"SITEID" VARCHAR2(25), 
	"SITE" VARCHAR2(50), 
	"MAXNESTLEVEL" NUMBER(10,0), 
	"PAGELIMIT" NUMBER(10,0), 
	"LOCKING" VARCHAR2(50), 
	"DOMAIN" VARCHAR2(100), 
	"EXPORTLOCATION" VARCHAR2(100), 
	"FILEDIR" VARCHAR2(50), 
	"CONTACT" VARCHAR2(50), 
	"MAILSERVERIP" VARCHAR2(50), 
	"MAILSERVERUSERNAME" VARCHAR2(50), 
	"MAILSERVERPASSWORD" VARCHAR2(50), 
	"EMAILBROADCASTER" NUMBER(10,0), 
	"EXTRANET" NUMBER(10,0), 
	"EXTRANETPUBLICREG" NUMBER(10,0), 
	"EXTRANETPUBLICREGNOTIFY" VARCHAR2(50), 
	"EXTRANETSSL" NUMBER(10,0), 
	"CACHE" NUMBER(10,0), 
	"VIEWDEPTH" NUMBER(10,0), 
	"NEXTN" NUMBER(10,0), 
	"DATACOLLECTION" NUMBER(10,0), 
	"COLUMNCOUNT" NUMBER(10,0), 
	"COLUMNNAMES" VARCHAR2(255), 
	"PRIMARYCOLUMN" NUMBER(10,0), 
	"PUBLICSUBMISSION" NUMBER(10,0), 
	"ADMANAGER" NUMBER(10,0), 
	"ARCHIVEDATE" DATE, 
	"CONTACTNAME" VARCHAR2(50), 
	"CONTACTADDRESS" VARCHAR2(50), 
	"CONTACTCITY" VARCHAR2(50), 
	"CONTACTSTATE" VARCHAR2(50), 
	"CONTACTZIP" VARCHAR2(50), 
	"CONTACTEMAIL" VARCHAR2(100), 
	"CONTACTPHONE" VARCHAR2(50), 
	"PRIVATEUSERPOOLID" VARCHAR2(50), 
	"PUBLICUSERPOOLID" VARCHAR2(50), 
	"ADVERTISERUSERPOOLID" VARCHAR2(50), 
	"ORDERNO" NUMBER(10,0), 
	"EMAILBROADCASTERLIMIT" NUMBER(10,0) DEFAULT '0', 
	"FEEDMANAGER" NUMBER(10,0), 
	"DISPLAYPOOLID" VARCHAR2(50), 
	"GALLERYMAINSCALEBY" VARCHAR2(50), 
	"GALLERYMAINSCALE" NUMBER(10,0), 
	"GALLERYSMALLSCALEBY" VARCHAR2(50), 
	"GALLERYSMALLSCALE" NUMBER(10,0), 
	"GALLERYMEDIUMSCALEBY" VARCHAR2(50), 
	"GALLERYMEDIUMSCALE" NUMBER(10,0), 
	"SENDLOGINSCRIPT" CLOB, 
	"MAILINGLISTCONFIRMSCRIPT" CLOB, 
	"PUBLICSUBMISSIONAPPROVALSCRIPT" CLOB, 
	"REMINDERSCRIPT" CLOB, 
	"LOGINURL" VARCHAR2(255), 
	"EDITPROFILEURL" VARCHAR2(255), 
	"COMMENTAPPROVALDEFAULT" NUMBER(3,0), 
	"DEPLOY" NUMBER(3,0), 
	"LASTDEPLOYMENT" DATE, 
	"ACCOUNTACTIVATIONSCRIPT" CLOB, 
	"GOOGLEAPIKEY" VARCHAR2(100),
    "USEDEFAULTSMTPSERVER" NUMBER(3,0),
	"THEME" VARCHAR2(50),
	"MAILSERVERSMTPPORT" VARCHAR2(5),
	"MAILSERVERPOPPORT" VARCHAR2(5),
	"MAILSERVERTLS" VARCHAR2(5),
	"MAILSERVERSSL" VARCHAR2(5)
   ) 
	lob (SENDLOGINSCRIPT, MAILINGLISTCONFIRMSCRIPT, PUBLICSUBMISSIONAPPROVALSCRIPT, REMINDERSCRIPT, ACCOUNTACTIVATIONSCRIPT) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TSYSTEMOBJECTS" 
   (	"OBJECT" VARCHAR2(50), 
	"SITEID" VARCHAR2(25), 
	"NAME" VARCHAR2(50), 
	"ORDERNO" NUMBER(10,0)
   ) ;
--|

  CREATE TABLE "TUSERADDRESSES" 
   (	"ADDRESSID" CHAR(35), 
	"USERID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"ADDRESSNAME" VARCHAR2(50), 
	"ADDRESS1" VARCHAR2(50), 
	"ADDRESS2" VARCHAR2(50), 
	"CITY" VARCHAR2(50), 
	"STATE" VARCHAR2(50), 
	"ZIP" VARCHAR2(50), 
	"COUNTRY" VARCHAR2(50), 
	"PHONE" VARCHAR2(50), 
	"FAX" VARCHAR2(50), 
	"ISPRIMARY" NUMBER(3,0), 
	"ADDRESSNOTES" CLOB, 
	"ADDRESSURL" VARCHAR2(200), 
	"LONGITUDE" FLOAT(126), 
	"LATITUDE" FLOAT(126), 
	"ADDRESSEMAIL" VARCHAR2(100), 
	"HOURS" CLOB
   ) 
	lob (ADDRESSNOTES, HOURS) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TUSERS" 
   (	"USERID" CHAR(35), 
	"GROUPNAME" VARCHAR2(50), 
	"FNAME" VARCHAR2(50), 
	"LNAME" VARCHAR2(50), 
	"USERNAME" VARCHAR2(50), 
	"PASSWORD" VARCHAR2(50), 
	"PASSWORDCREATED" DATE, 
	"EMAIL" VARCHAR2(100), 
	"COMPANY" VARCHAR2(50), 
	"JOBTITLE" VARCHAR2(50), 
	"MOBILEPHONE" VARCHAR2(50), 
	"WEBSITE" VARCHAR2(255), 
	"TYPE" NUMBER(10,0), 
	"SUBTYPE" VARCHAR2(50), 
	"EXT" NUMBER(10,0), 
	"CONTACTFORM" CLOB, 
	"ADMIN" NUMBER(10,0), 
	"S2" NUMBER(10,0), 
	"LASTLOGIN" DATE, 
	"LASTUPDATE" DATE, 
	"LASTUPDATEBY" VARCHAR2(50), 
	"LASTUPDATEBYID" VARCHAR2(35), 
	"PERM" NUMBER(3,0), 
	"INACTIVE" NUMBER(3,0), 
	"ISPUBLIC" NUMBER(10,0), 
	"SITEID" VARCHAR2(50), 
	"SUBSCRIBE" NUMBER(10,0), 
	"NOTES" CLOB, 
	"DESCRIPTION" CLOB, 
	"INTERESTS" CLOB, 
	"KEEPPRIVATE" NUMBER(3,0), 
	"PHOTOFILEID" VARCHAR2(35), 
	"IMNAME" VARCHAR2(100), 
	"IMSERVICE" VARCHAR2(50), 
	"CREATED" DATE DEFAULT SYSDATE, 
	"REMOTEID" VARCHAR2(35), 
	"TAGS" CLOB
   )
 	lob (NOTES,DESCRIPTION,INTERESTS,TAGS) STORE AS (
	TABLESPACE <cfoutput>"#form.production_dbtablespace#"</cfoutput> ENABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 10
	NOCACHE LOGGING
	STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
	PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT));
--|

  CREATE TABLE "TUSERSFAVORITES" 
   (	"FAVORITEID" CHAR(35), 
	"USERID" CHAR(35), 
	"FAVORITENAME" VARCHAR2(100), 
	"TYPE" VARCHAR2(30), 
	"SITEID" VARCHAR2(35), 
	"DATECREATED" DATE DEFAULT SYSDATE, 
	"COLUMNNUMBER" NUMBER(10,0), 
	"ROWNUMBER" NUMBER(10,0), 
	"MAXRSSITEMS" NUMBER(10,0), 
	"FAVORITE" VARCHAR2(400)
   ) ;
--|

  CREATE TABLE "TUSERSINTERESTS" 
   (	"USERID" CHAR(35), 
	"CATEGORYID" CHAR(35)
   ) ;
--|

  CREATE TABLE "TUSERSMEMB" 
   (	"USERID" CHAR(35), 
	"GROUPID" CHAR(35)
   ) ;
--|

  CREATE TABLE "TUSERSTAGS" 
   (	"TAGID" NUMBER(10,0), 
	"USERID" CHAR(35), 
	"SITEID" VARCHAR2(25), 
	"TAG" VARCHAR2(100)
   ) ;
--|

  ALTER TABLE "TADCAMPAIGNS" ADD CONSTRAINT "PRIMARY_16" PRIMARY KEY ("CAMPAIGNID") ENABLE;
--|
 
  ALTER TABLE "TADCAMPAIGNS" MODIFY ("CAMPAIGNID" NOT NULL ENABLE);
--|

  ALTER TABLE "TADCREATIVES" ADD CONSTRAINT "PRIMARY_9" PRIMARY KEY ("CREATIVEID") ENABLE;
--|
  ALTER TABLE "TADCREATIVES" MODIFY ("CREATIVEID" NOT NULL ENABLE);
--|

  ALTER TABLE "TADIPWHITELIST" MODIFY ("IP" NOT NULL ENABLE);
--|
  ALTER TABLE "TADIPWHITELIST" MODIFY ("SITEID" NOT NULL ENABLE);
--|

  ALTER TABLE "TADPLACEMENTDETAILS" ADD CONSTRAINT "PRIMARY_10" PRIMARY KEY ("DETAILID") ENABLE;
--|
  ALTER TABLE "TADPLACEMENTDETAILS" MODIFY ("DETAILID" NOT NULL ENABLE);
--|
  ALTER TABLE "TADPLACEMENTDETAILS" MODIFY ("PLACEMENTID" NOT NULL ENABLE);
--|
  ALTER TABLE "TADPLACEMENTDETAILS" MODIFY ("PLACEMENTTYPE" NOT NULL ENABLE);
--|
  ALTER TABLE "TADPLACEMENTDETAILS" MODIFY ("PLACEMENTVALUE" NOT NULL ENABLE);
--|

  ALTER TABLE "TADPLACEMENTS" ADD CONSTRAINT "PRIMARY_17" PRIMARY KEY ("PLACEMENTID") ENABLE;
--|
  ALTER TABLE "TADPLACEMENTS" MODIFY ("PLACEMENTID" NOT NULL ENABLE);
--|

  ALTER TABLE "TADSTATS" ADD CONSTRAINT "PRIMARY_32" PRIMARY KEY ("STATID") ENABLE;
--|
  ALTER TABLE "TADSTATS" MODIFY ("STATID" NOT NULL ENABLE);
--|

  ALTER TABLE "TADZONES" ADD CONSTRAINT "PRIMARY_24" PRIMARY KEY ("ADZONEID") ENABLE;
--|
  ALTER TABLE "TADZONES" MODIFY ("ADZONEID" NOT NULL ENABLE);
--|
  ALTER TABLE "TCAPTCHA" MODIFY ("LETTERID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCLASSEXTEND" ADD CONSTRAINT "PRIMARY_29" PRIMARY KEY ("SUBTYPEID") ENABLE;
--|
  ALTER TABLE "TCLASSEXTEND" MODIFY ("SUBTYPEID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCLASSEXTENDATTRIBUTES" ADD CONSTRAINT "PRIMARY" PRIMARY KEY ("ATTRIBUTEID") ENABLE;
--|
  ALTER TABLE "TCLASSEXTENDATTRIBUTES" MODIFY ("ATTRIBUTEID" NOT NULL ENABLE);
--|


  ALTER TABLE "TCLASSEXTENDDATA" ADD CONSTRAINT "PRIMARY_1" PRIMARY KEY ("DATAID") ENABLE;
--| 
  ALTER TABLE "TCLASSEXTENDDATA" MODIFY ("DATAID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCLASSEXTENDDATA" MODIFY ("BASEID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCLASSEXTENDDATA" MODIFY ("ATTRIBUTEID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCLASSEXTENDDATAUSERACTIVITY" ADD CONSTRAINT "PRIMARY_11" PRIMARY KEY ("DATAID") ENABLE;
--|
  ALTER TABLE "TCLASSEXTENDDATAUSERACTIVITY" MODIFY ("DATAID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCLASSEXTENDDATAUSERACTIVITY" MODIFY ("BASEID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCLASSEXTENDDATAUSERACTIVITY" MODIFY ("ATTRIBUTEID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCLASSEXTENDSETS" ADD CONSTRAINT "PRIMARY_34" PRIMARY KEY ("EXTENDSETID") ENABLE;
--| 
  ALTER TABLE "TCLASSEXTENDSETS" MODIFY ("EXTENDSETID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENT" ADD CONSTRAINT "PRIMARY_5" PRIMARY KEY ("TCONTENT_ID") ENABLE;
--| 
  ALTER TABLE "TCONTENT" MODIFY ("TCONTENT_ID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENT" MODIFY ("FORCESSL" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTASSIGNMENTS" ADD CONSTRAINT "PRIMARY_30" PRIMARY KEY ("CONTENTID", "CONTENTHISTID", "SITEID", "USERID") ENABLE;
--|
  ALTER TABLE "TCONTENTASSIGNMENTS" MODIFY ("CONTENTID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTASSIGNMENTS" MODIFY ("CONTENTHISTID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTASSIGNMENTS" MODIFY ("SITEID" NOT NULL ENABLE);
--|
  ALTER TABLE "TCONTENTASSIGNMENTS" MODIFY ("USERID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTCATEGORIES" ADD CONSTRAINT "PRIMARY_6" PRIMARY KEY ("CATEGORYID") ENABLE;
--| 
  ALTER TABLE "TCONTENTCATEGORIES" MODIFY ("CATEGORYID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTCATEGORYASSIGN" ADD CONSTRAINT "PRIMARY_19" PRIMARY KEY ("CONTENTHISTID", "CATEGORYID") ENABLE;
--| 
  ALTER TABLE "TCONTENTCATEGORYASSIGN" MODIFY ("CONTENTHISTID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTCATEGORYASSIGN" MODIFY ("CATEGORYID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTCOMMENTS" ADD CONSTRAINT "PRIMARY_12" PRIMARY KEY ("COMMENTID") ENABLE;
--| 
  ALTER TABLE "TCONTENTCOMMENTS" MODIFY ("COMMENTID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTDISPLAYTITLEAPPROVALS" MODIFY ("CONTENTID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTEVENTREMINDERS" MODIFY ("CONTENTID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTEVENTREMINDERS" MODIFY ("SITEID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTEVENTREMINDERS" MODIFY ("EMAIL" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTFEEDADVANCEDPARAMS" ADD CONSTRAINT "PRIMARY_31" PRIMARY KEY ("PARAMID") ENABLE;
--|
  ALTER TABLE "TCONTENTFEEDADVANCEDPARAMS" MODIFY ("PARAMID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTFEEDADVANCEDPARAMS" MODIFY ("FEEDID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTFEEDITEMS" MODIFY ("FEEDID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTFEEDITEMS" MODIFY ("ITEMID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTFEEDS" ADD CONSTRAINT "PRIMARY_21" PRIMARY KEY ("FEEDID") ENABLE;
--| 
  ALTER TABLE "TCONTENTFEEDS" MODIFY ("FEEDID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTOBJECTS" ADD CONSTRAINT "PRIMARY_27" PRIMARY KEY ("CONTENTHISTID", "OBJECTID", "OBJECT", "COLUMNID") ENABLE;
--| 
  ALTER TABLE "TCONTENTOBJECTS" MODIFY ("CONTENTHISTID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTOBJECTS" MODIFY ("OBJECTID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTOBJECTS" MODIFY ("OBJECT" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTOBJECTS" MODIFY ("COLUMNID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTPUBLICSUBMISSIONAPPROV" ADD CONSTRAINT "PRIMARY_13" PRIMARY KEY ("CONTENTID", "SITEID") ENABLE;
--|
 
  ALTER TABLE "TCONTENTPUBLICSUBMISSIONAPPROV" MODIFY ("CONTENTID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTPUBLICSUBMISSIONAPPROV" MODIFY ("ISAPPROVED" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTPUBLICSUBMISSIONAPPROV" MODIFY ("EMAIL" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTPUBLICSUBMISSIONAPPROV" MODIFY ("SITEID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTRATINGS" ADD CONSTRAINT "PRIMARY_14" PRIMARY KEY ("CONTENTID", "USERID", "SITEID") ENABLE;
--|
 
  ALTER TABLE "TCONTENTRATINGS" MODIFY ("CONTENTID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTRATINGS" MODIFY ("USERID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTRATINGS" MODIFY ("SITEID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTRELATED" ADD CONSTRAINT "PRIMARY_22" PRIMARY KEY ("CONTENTHISTID", "RELATEDID", "CONTENTID", "SITEID") ENABLE;
--|
 
  ALTER TABLE "TCONTENTRELATED" MODIFY ("CONTENTHISTID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTRELATED" MODIFY ("RELATEDID" NOT NULL ENABLE);
--| 
  ALTER TABLE "TCONTENTRELATED" MODIFY ("CONTENTID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTRELATED" MODIFY ("SITEID" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTSTATS" ADD CONSTRAINT "PRIMARY_23" PRIMARY KEY ("CONTENTID", "SITEID") ENABLE;
--|
 
  ALTER TABLE "TCONTENTSTATS" MODIFY ("CONTENTID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTSTATS" MODIFY ("SITEID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTSTATS" MODIFY ("VIEWS" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTSTATS" MODIFY ("RATING" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTSTATS" MODIFY ("TOTALVOTES" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTSTATS" MODIFY ("UPVOTES" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTSTATS" MODIFY ("DOWNVOTES" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTSTATS" MODIFY ("COMMENTS" NOT NULL ENABLE);
--|

  ALTER TABLE "TCONTENTTAGS" ADD CONSTRAINT "PRIMARY_33" PRIMARY KEY ("TAGID") ENABLE;
--|
 
  ALTER TABLE "TCONTENTTAGS" MODIFY ("TAGID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTTAGS" MODIFY ("CONTENTID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTTAGS" MODIFY ("CONTENTHISTID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTTAGS" MODIFY ("SITEID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TCONTENTTAGS" MODIFY ("TAG" NOT NULL ENABLE);
--|

  ALTER TABLE "TEMAILS" ADD CONSTRAINT "PRIMARY_28" PRIMARY KEY ("EMAILID") ENABLE;
--|
 
  ALTER TABLE "TEMAILS" MODIFY ("EMAILID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TEMAILS" MODIFY ("NUMBERSENT" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TEMAILS" MODIFY ("ISDELETED" NOT NULL ENABLE);
--|

  ALTER TABLE "TEMAILSTATS" MODIFY ("EMAILOPEN" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TEMAILSTATS" MODIFY ("RETURNCLICK" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TEMAILSTATS" MODIFY ("BOUNCE" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TEMAILSTATS" MODIFY ("SENT" NOT NULL ENABLE);
--|

  ALTER TABLE "TFILES" ADD CONSTRAINT "PRIMARY_20" PRIMARY KEY ("FILEID") ENABLE;
--|

  ALTER TABLE "TFILES" MODIFY ("FILEID" NOT NULL ENABLE);
--|

  ALTER TABLE "TFORMRESPONSEPACKETS" ADD CONSTRAINT "PRIMARY_7" PRIMARY KEY ("RESPONSEID") ENABLE;
--|
 
  ALTER TABLE "TFORMRESPONSEPACKETS" MODIFY ("RESPONSEID" NOT NULL ENABLE);
--|

  ALTER TABLE "TMAILINGLISTMEMBERS" MODIFY ("ISVERIFIED" NOT NULL ENABLE);
--|

  ALTER TABLE "TREDIRECTS" ADD CONSTRAINT "PRIMARY_15" PRIMARY KEY ("REDIRECTID") ENABLE;
--|
 
  ALTER TABLE "TREDIRECTS" MODIFY ("REDIRECTID" NOT NULL ENABLE);
--|

  ALTER TABLE "TSESSIONTRACKING" ADD CONSTRAINT "PRIMARY_8" PRIMARY KEY ("TRACKINGID") ENABLE;
--|
 
  ALTER TABLE "TSESSIONTRACKING" MODIFY ("TRACKINGID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TSESSIONTRACKING" MODIFY ("URLTOKEN" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TSESSIONTRACKING" MODIFY ("ENTERED" NOT NULL ENABLE);
--|

  ALTER TABLE "TSETTINGS" MODIFY ("EMAILBROADCASTERLIMIT" NOT NULL ENABLE);
--|

  ALTER TABLE "TUSERADDRESSES" ADD CONSTRAINT "PRIMARY_3" PRIMARY KEY ("ADDRESSID") ENABLE;
--|

  ALTER TABLE "TUSERADDRESSES" MODIFY ("ADDRESSID" NOT NULL ENABLE);
--|

  ALTER TABLE "TUSERS" ADD CONSTRAINT "PRIMARY_25" PRIMARY KEY ("USERID") ENABLE;
--|

  ALTER TABLE "TUSERS" MODIFY ("USERID" NOT NULL ENABLE);
--|

  ALTER TABLE "TUSERSFAVORITES" ADD CONSTRAINT "PRIMARY_2" PRIMARY KEY ("FAVORITEID") ENABLE;
--|
 
  ALTER TABLE "TUSERSFAVORITES" MODIFY ("FAVORITEID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TUSERSFAVORITES" MODIFY ("USERID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TUSERSFAVORITES" MODIFY ("TYPE" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TUSERSFAVORITES" MODIFY ("DATECREATED" NOT NULL ENABLE);
--|

  ALTER TABLE "TUSERSINTERESTS" ADD CONSTRAINT "PRIMARY_26" PRIMARY KEY ("USERID", "CATEGORYID") ENABLE;
--|
 
  ALTER TABLE "TUSERSINTERESTS" MODIFY ("USERID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TUSERSINTERESTS" MODIFY ("CATEGORYID" NOT NULL ENABLE);
--|

  ALTER TABLE "TUSERSMEMB" ADD CONSTRAINT "PRIMARY_4" PRIMARY KEY ("USERID", "GROUPID") ENABLE;
--|
 
  ALTER TABLE "TUSERSMEMB" MODIFY ("USERID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TUSERSMEMB" MODIFY ("GROUPID" NOT NULL ENABLE);
--|

  ALTER TABLE "TUSERSTAGS" ADD CONSTRAINT "PRIMARY_18" PRIMARY KEY ("TAGID") ENABLE;
--|
 
  ALTER TABLE "TUSERSTAGS" MODIFY ("TAGID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TUSERSTAGS" MODIFY ("USERID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TUSERSTAGS" MODIFY ("SITEID" NOT NULL ENABLE);
--|
 
  ALTER TABLE "TUSERSTAGS" MODIFY ("TAG" NOT NULL ENABLE);
--|

  CREATE INDEX "CASELESS_MENUTITLE_INDEX" ON "TCONTENT" (NLSSORT("MENUTITLE",'nls_sort=''BINARY_CI''')) 
  ;
--|

  CREATE INDEX "CASELESS_TITLE_INDEX" ON "TCONTENT" (NLSSORT("TITLE",'nls_sort=''BINARY_CI''')) 
  ;
--|

  CREATE INDEX "IDX_ENTERED" ON "TCONTENTRATINGS" ("ENTERED") 
  ;
--|

  CREATE INDEX "IDX_ENTERED_1" ON "TSESSIONTRACKING" ("ENTERED") 
  ;
--|

  CREATE INDEX "INDEX_2" ON "TCLASSEXTENDATTRIBUTES" ("EXTENDSETID") 
  ;
--|

  CREATE INDEX "INDEX_2_1" ON "TCLASSEXTENDDATA" ("BASEID") 
  ;
--|

  CREATE INDEX "INDEX_2_2" ON "TCLASSEXTENDDATAUSERACTIVITY" ("BASEID") 
  ;
--|

  CREATE INDEX "INDEX_2_3" ON "TCONTENTTAGS" ("CONTENTHISTID") 
  ;
--|

  CREATE INDEX "INDEX_2_4" ON "TUSERADDRESSES" ("LONGITUDE") 
  ;
--|
  CREATE INDEX "INDEX_2_5" ON "TCLASSEXTENDSETS" ("SUBTYPEID") 
  ;
--|

  CREATE INDEX "INDEX_2_6" ON "TUSERSTAGS" ("USERID") 
  ;
--|

  CREATE INDEX "INDEX_3" ON "TCLASSEXTENDDATA" ("ATTRIBUTEID") 
  ;
--|

  CREATE INDEX "INDEX_3_1" ON "TCONTENTTAGS" ("SITEID") 
  ;
--|

  CREATE INDEX "INDEX_3_2" ON "TUSERADDRESSES" ("LATITUDE") 
  ;
--|

  CREATE INDEX "INDEX_3_3" ON "TUSERSTAGS" ("SITEID") 
  ;
--|

CREATE INDEX "INDEX_3_4" ON "TCLASSEXTENDDATAUSERACTIVITY" ("ATTRIBUTEID") 
  ;
--|

  CREATE INDEX "INDEX_4" ON "TCONTENTTAGS" ("CONTENTID") 
  ;
--|

  CREATE INDEX "INDEX_4_1" ON "TUSERSTAGS" ("TAG") 
  ;
--|

  CREATE INDEX "INDEX_4_2" ON "TUSERADDRESSES" ("USERID") 
  ;
--|

  CREATE INDEX "INDEX_5" ON "TCONTENTTAGS" ("TAG") 
  ;
--|

  CREATE INDEX "IX_TCONTENT" ON "TCONTENT" ("CONTENTID") 
  ;
--|

  CREATE INDEX "IX_TCONTENTCATEGORIES" ON "TCONTENTCATEGORIES" ("SITEID") 
  ;
--|

  CREATE INDEX "IX_TCONTENTCOMMENTS" ON "TCONTENTCOMMENTS" ("CONTENTID") 
  ;
--|

  ALTER INDEX "IX_TCONTENTCOMMENTS"  UNUSABLE;
--|

  CREATE INDEX "IX_TCONTENTFEEDS" ON "TCONTENTFEEDS" ("SITEID") 
  ;
--|

  CREATE INDEX "IX_TCONTENTOBJECTS" ON "TCONTENTOBJECTS" ("SITEID") 
  ;
--|

  CREATE INDEX "IX_TCONTENT_1" ON "TCONTENT" ("CONTENTHISTID") 
  ;
--|

  CREATE INDEX "IX_TCONTENT_2" ON "TCONTENT" ("SITEID") 
  ;
--|

  CREATE INDEX "IX_TCONTENT_3" ON "TCONTENT" ("PARENTID") 
  ;
--|

  CREATE INDEX "IX_TCONTENT_4" ON "TCONTENT" ("REMOTEID") 
  ;
--|

  CREATE INDEX "IX_TCONTENT_5" ON "TCONTENT" ("MODULEID") 
  ;
--|

  CREATE INDEX "IX_TEMAILS" ON "TEMAILS" ("SITEID") 
  ;
--|

  CREATE INDEX "IX_TFORMRESPONSEPACKETS" ON "TFORMRESPONSEPACKETS" ("FORMID", "SITEID") 
  ;
--|

  CREATE INDEX "IX_TSESSIONTRACKING" ON "TSESSIONTRACKING" ("SITEID") 
  ;
--|

  CREATE INDEX "IX_TSESSIONTRACKING_1" ON "TSESSIONTRACKING" ("CONTENTID") 
  ;
--|

  CREATE INDEX "IX_TSESSIONTRACKING_2" ON "TSESSIONTRACKING" ("URLTOKEN") 
  ;
--|

  CREATE INDEX "IX_TSESSIONTRACKING_3" ON "TSESSIONTRACKING" ("USERID") 
  ;
--|

CREATE OR REPLACE TRIGGER "TADPLACEMENTDETAILS_DETAILID_T" BEFORE INSERT ON tadplacementdetails
FOR EACH ROW
BEGIN
    select tadplacementdetails_detailID_S.nextval into :new.detailID from dual;
END;
/
--|

ALTER TRIGGER "TADPLACEMENTDETAILS_DETAILID_T" ENABLE;
--|

CREATE OR REPLACE TRIGGER "TADSTATS_STATID_TRG" BEFORE INSERT ON tadstats
FOR EACH ROW
BEGIN
    select tadstats_statID_SEQ.nextval into :new.statID from dual;
END;
/
--|

ALTER TRIGGER "TADSTATS_STATID_TRG" ENABLE;
--|

CREATE OR REPLACE TRIGGER "TCLASSEXTENDATTRIBUTES_ATTRI_1" BEFORE INSERT ON tclassextendattributes
FOR EACH ROW
BEGIN
    select tclassextendattributes_attribu.NEXTVAL into :new.attributeID from dual;
END;
/
--|

ALTER TRIGGER "TCLASSEXTENDATTRIBUTES_ATTRI_1" ENABLE;
--|

CREATE OR REPLACE TRIGGER "TCLASSEXTENDDATAUSERACTIVITY_1" BEFORE INSERT ON tclassextenddatauseractivity
FOR EACH ROW
BEGIN
   select tclassextenddatauseractivity_d.NEXTVAL into :new.dataID from dual;
END;
/
--|

ALTER TRIGGER "TCLASSEXTENDDATAUSERACTIVITY_1" ENABLE;
--|

CREATE OR REPLACE TRIGGER "TCLASSEXTENDDATA_DATAID_TRG" BEFORE INSERT ON tclassextenddata
FOR EACH ROW
BEGIN
   	select tclassextenddata_dataID_SEQ.NEXTVAL into :new.dataID from dual;
END;
/
--|

ALTER TRIGGER "TCLASSEXTENDDATA_DATAID_TRG" ENABLE;
--|

CREATE OR REPLACE TRIGGER "TCONTENTTAGS_TAGID_TRG" BEFORE INSERT ON tcontenttags
FOR EACH ROW
BEGIN
   select tcontenttags_tagID_SEQ.NEXTVAL into :new.tagID from dual;
END;
/
--|

ALTER TRIGGER "TCONTENTTAGS_TAGID_TRG" ENABLE;
--|

CREATE OR REPLACE TRIGGER "TCONTENT_TCONTENT_ID_TRG" BEFORE INSERT ON tcontent
FOR EACH ROW
BEGIN
   select tcontent_tcontent_ID_SEQ.nextval into :new.TContent_ID from dual;
END;
/
--|

ALTER TRIGGER "TCONTENT_TCONTENT_ID_TRG" ENABLE;
--|

CREATE OR REPLACE TRIGGER "TSESSIONTRACKING_TRACKINGID_TR" BEFORE INSERT ON tsessiontracking
FOR EACH ROW
BEGIN
    select tsessiontracking_trackingID_SE.nextval into :new.trackingID from dual;
END;
/
--|

ALTER TRIGGER "TSESSIONTRACKING_TRACKINGID_TR" ENABLE;
--|

CREATE OR REPLACE TRIGGER "TUSERSTAGS_TAGID_TRG" BEFORE INSERT on tuserstags 
FOR EACH ROW
BEGIN
    select tuserstags_tagID_SEQ.nextval into :new.tagID from dual;
END;
/
--|

ALTER TRIGGER "TUSERSTAGS_TAGID_TRG" ENABLE;
--|

Insert into TSETTINGS (SITEID,SITE,MAXNESTLEVEL,PAGELIMIT,LOCKING,DOMAIN,EXPORTLOCATION,FILEDIR,CONTACT,MAILSERVERIP,MAILSERVERUSERNAME,MAILSERVERPASSWORD,EMAILBROADCASTER,EXTRANET,EXTRANETPUBLICREG,EXTRANETPUBLICREGNOTIFY,EXTRANETSSL,CACHE,VIEWDEPTH,NEXTN,DATACOLLECTION,COLUMNCOUNT,COLUMNNAMES,PRIMARYCOLUMN,PUBLICSUBMISSION,ADMANAGER,ARCHIVEDATE,CONTACTNAME,CONTACTADDRESS,CONTACTCITY,CONTACTSTATE,CONTACTZIP,CONTACTEMAIL,CONTACTPHONE,PRIVATEUSERPOOLID,PUBLICUSERPOOLID,ADVERTISERUSERPOOLID,ORDERNO,EMAILBROADCASTERLIMIT,FEEDMANAGER,DISPLAYPOOLID,GALLERYMAINSCALEBY,GALLERYMAINSCALE,GALLERYSMALLSCALEBY,GALLERYSMALLSCALE,GALLERYMEDIUMSCALEBY,GALLERYMEDIUMSCALE,SENDLOGINSCRIPT,MAILINGLISTCONFIRMSCRIPT,PUBLICSUBMISSIONAPPROVALSCRIPT,REMINDERSCRIPT,LOGINURL,EDITPROFILEURL,COMMENTAPPROVALDEFAULT,DEPLOY,LASTDEPLOYMENT,ACCOUNTACTIVATIONSCRIPT,GOOGLEAPIKEY,USEDEFAULTSMTPSERVER) values ('default','Default',null,1000,'none','localhost',null,null,'info@getmura.com','mail.server.com','username@server.com','password',1,1,1,null,0,0,1,20,1,3,'Left Column^Main Content^Right Column',2,0,1,null,null,null,null,null,null,null,null,'default','default','default',1,0,1,'default','y',500,'s',100,'y',250,null,null,null,null,'?display=login','?display=editProfile',0,0,null,null,null,0);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('event_reminder_form','default','Event Reminder Form',12);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('forward_email','default','Forward Email',13);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('site_map','default','Site Map',2);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('peer_nav','default','Peer Navigation',3);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('sub_nav','default','Sub Navigation',4);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('standard_nav','default','Standard Navigation',5);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('portal_nav','default','Portal Navigation',6);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('comments','default','Accept Comments',9);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('seq_nav','default','Sequential Nav',8);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('rater','default','Content Rater',16);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('favorites','default','User Favorites',17);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('dragable_feeds','default','Dragable Feeds',18);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('related_content','default','Related Content',19);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('user_tools','default','User Tools',20);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('tag_cloud','default','Tag Cloud',21);
--|

Insert into TSYSTEMOBJECTS (OBJECT,SITEID,NAME,ORDERNO) values ('goToFirstChild','default','Go To First Child',23);
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (1,'a','a.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (2,'b','b.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (3,'c','c.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (4,'d','d.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (5,'e','e.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (6,'f','f.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (7,'g','g.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (8,'h','h.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (9,'i','i.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (10,'j','j.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (11,'k','k.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (12,'l','l.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (13,'m','m.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (14,'n','n.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (15,'o','o.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (16,'p','p.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (17,'q','q.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (18,'r','r.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (19,'s','s.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (20,'t','t.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (21,'u','u.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (22,'v','v.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (23,'w','w.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (24,'x','x.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (25,'y','y.gif');
--|

Insert into TCAPTCHA (LETTERID,LETTER,IMAGEFILE) values (26,'z','z.gif');
--|

<cfoutput>
Insert into TUSERS (USERID,GROUPNAME,FNAME,LNAME,USERNAME,PASSWORD,PASSWORDCREATED,EMAIL,COMPANY,JOBTITLE,MOBILEPHONE,WEBSITE,TYPE,SUBTYPE,EXT,CONTACTFORM,ADMIN,S2,LASTLOGIN,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,PERM,INACTIVE,ISPUBLIC,SITEID,SUBSCRIBE,NOTES,DESCRIPTION,INTERESTS,KEEPPRIVATE,PHOTOFILEID,IMNAME,IMSERVICE,CREATED,REMOTEID,TAGS) values ('#adminUserID#',null,'Admin','User','admin','21232F297A57A5A743894A0E4A801FC3',to_timestamp('24-SEP-07 04.49.00.000000000 PM','DD-MON-RR HH.MI.SS.FF AM'),'admin@localhost.com',null,null,null,null,2,'Default',null,null,null,1,to_timestamp('02-SEP-08 03.53.59.000000000 PM','DD-MON-RR HH.MI.SS.FF AM'),to_timestamp('25-AUG-08 07.03.09.000000000 PM','DD-MON-RR HH.MI.SS.FF AM'),'Admin User','22FC551F-FABE-EA01-C6EDD0885DDC1682',0,0,0,'default',0,null,null,null,0,null,null,null,to_timestamp('24-SEP-07 04.49.02.000000000 PM','DD-MON-RR HH.MI.SS.FF AM'),null,null);
--|

Insert into TUSERS (USERID,GROUPNAME,FNAME,LNAME,USERNAME,PASSWORD,PASSWORDCREATED,EMAIL,COMPANY,JOBTITLE,MOBILEPHONE,WEBSITE,TYPE,SUBTYPE,EXT,CONTACTFORM,ADMIN,S2,LASTLOGIN,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,PERM,INACTIVE,ISPUBLIC,SITEID,SUBSCRIBE,NOTES,DESCRIPTION,INTERESTS,KEEPPRIVATE,PHOTOFILEID,IMNAME,IMSERVICE,CREATED,REMOTEID,TAGS) values ('#createUUID()#','Admin',null,null,null,null,null,null,null,null,null,null,1,'Default',null,null,null,0,null,to_timestamp('24-SEP-07 04.49.00.000000000 PM','DD-MON-RR HH.MI.SS.FF AM'),'System',null,1,0,0,'default',0,null,null,null,0,null,null,null,to_timestamp('24-SEP-07 04.49.02.000000000 PM','DD-MON-RR HH.MI.SS.FF AM'),null,null);
--|
</cfoutput>

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (1,'default','00000000000000000000000000000000003','00000000000000000000000000000000END','00000000000000000000000000000000003','6300ED4A-1320-5CC3-F9D6A2D279E386D0',null,null,null,null,null,null,null,null,'Module','Default',1,null,'Components',null,null,null,null,null,null,null,null,null,null,null,1,1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,null,null,null,null,null);
--|

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (2,'default','00000000000000000000000000000000004','00000000000000000000000000000000END','00000000000000000000000000000000004','6300ED59-1320-5CC3-F9706221E0EFF7A2',null,null,null,null,null,null,null,null,'Module','Default',1,null,'Forms',null,null,null,null,null,null,null,null,null,null,null,1,1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,null,null,0,null,null);
--|

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (4,'default','00000000000000000000000000000000006','00000000000000000000000000000000END','00000000000000000000000000000000006','6300ED79-1320-5CC3-F92E6325C26664B6',null,null,null,null,null,null,null,null,'Module','Default',1,null,'Advertising',null,null,null,null,null,null,null,null,null,null,null,1,1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,null,null,0,null,null);
--|

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (5,'default','00000000000000000000000000000000000','00000000000000000000000000000000END','00000000000000000000000000000000000','6300ED88-1320-5CC3-F9E241684D21FEC9',null,null,null,null,null,null,null,null,'Module','Default',1,null,'Site Manager',null,null,null,null,null,null,null,null,null,null,null,1,1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,null,null,0,null,null);
--|

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (6,'default','00000000000000000000000000000000008','00000000000000000000000000000000END','00000000000000000000000000000000008','6300ED98-1320-5CC3-F9398EB23A57CBD0',null,null,null,null,null,null,null,null,'Module','Default',1,null,'Site Members',null,null,null,null,null,null,null,null,null,null,null,1,1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,null,null,0,null,null);
--|

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (7,'default','00000000000000000000000000000000005','00000000000000000000000000000000END','00000000000000000000000000000000005','6300EDA8-1320-5CC3-F93DF074187C935E',null,null,null,null,null,null,null,null,'Module','Default',1,null,'Email Broadcaster',null,null,null,null,null,null,null,null,null,null,null,1,1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,null,null,0,null,null);
--|

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (8,'default','00000000000000000000000000000000009','00000000000000000000000000000000END','00000000000000000000000000000000009','6300EDB7-1320-5CC3-F9D664F38EBBD2D0',null,null,null,null,null,null,null,null,'Module','Default',1,null,'Mailing Lists',null,null,null,null,null,null,null,null,null,null,null,1,1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,null,null,0,null,null);
--|

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (9,'default','00000000000000000000000000000000010','00000000000000000000000000000000END','00000000000000000000000000000000010','6300EDC7-1320-5CC3-F9DB8034C9626B70',null,null,null,null,null,null,null,null,'Module','Default',1,null,'Categories',null,null,null,null,null,null,null,null,null,null,null,1,1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,null,null,0,null,null);
--|

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (10,'default','00000000000000000000000000000000011','00000000000000000000000000000000END','00000000000000000000000000000000011','6300EDD6-1320-5CC3-F9625545444B880F',null,null,null,null,null,null,null,null,'Module','Default',1,null,'Content Collections',null,null,null,null,null,null,null,null,null,null,null,1,1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,null,null,0,null,null);
--|

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (11,'default','00000000000000000000000000000000012','00000000000000000000000000000000END','00000000000000000000000000000000012','6300EDE6-1320-5CC3-F94E2FCEF5DE046D',null,null,null,null,null,null,null,null,'Module','Default',1,null,'Filemanager Manager',null,null,null,null,null,null,null,null,null,null,null,1,1,1,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,0,null,null,0,null,null);
--|

Insert into TCONTENT (TCONTENT_ID,SITEID,MODULEID,PARENTID,CONTENTID,CONTENTHISTID,REMOTEID,REMOTEURL,REMOTEPUBDATE,REMOTESOURCEURL,REMOTESOURCE,CREDITS,FILEID,TEMPLATE,TYPE,SUBTYPE,ACTIVE,ORDERNO,TITLE,MENUTITLE,SUMMARY,FILENAME,METADESC,METAKEYWORDS,BODY,LASTUPDATE,LASTUPDATEBY,LASTUPDATEBYID,DISPLAYSTART,DISPLAYSTOP,DISPLAY,APPROVED,ISNAV,RESTRICTED,RESTRICTGROUPS,TARGET,TARGETPARAMS,RESPONSECHART,RESPONSEMESSAGE,RESPONSESENDTO,RESPONSEDISPLAYFIELDS,MODULEASSIGN,DISPLAYTITLE,NOTES,INHERITOBJECTS,ISFEATURE,RELEASEDATE,ISLOCKED,NEXTN,SORTBY,SORTDIRECTION,FEATURESTART,FEATURESTOP,FORCESSL,AUDIENCE,KEYPOINTS,SEARCHEXCLUDE,PATH,TAGS) values (201,'default','00000000000000000000000000000000000','00000000000000000000000000000000END','00000000000000000000000000000000001','25D40CD9-07FD-7B66-B7A4514DADB379DD',null,null,null,null,null,null,null,'default.cfm','Page','Default',1,1,'Home','Home',null,null,null,null,null,to_timestamp('02-SEP-08 06.29.26.000000000 PM','DD-MON-RR HH.MI.SS.FF AM'),'Admin User','22FC551F-FABE-EA01-C6EDD0885DDC1682',null,null,1,1,0,0,null,'_self',null,0,null,null,null,null,0,null,'Cascade',0,null,0,10,'orderno','asc',null,null,0,null,null,0,'',null);
--|

Insert into TGLOBALS (APPRELOAD,LOADLIST) values (to_timestamp('02-SEP-08 11.18.54.000000000 AM','DD-MON-RR HH.MI.SS.FF AM'),null);
--|

<cfoutput>
Insert into TMAILINGLIST (MLID,SITEID,NAME,DESCRIPTION,LASTUPDATE,ISPURGE,ISPUBLIC) values ('#createUUID()#','default','Please Remove Me from All Lists','',to_timestamp('24-SEP-07 04.49.00.000000000 PM','DD-MON-RR HH.MI.SS.FF AM'),1,1);
--|
</cfoutput>

COMMIT;
